unit SubUnit;
interface
uses windows,winsock,{SysUtils,}shFolder, WinInet;
//     SysUtils.pas     
//  ..  ~15   exe 
Const
  ListBufSize = $FFFF;

  faReadOnly  = $00000001 ;
  faHidden    = $00000002 ;
  faSysFile   = $00000004 ;
  faVolumeID  = $00000008 ;
  faDirectory = $00000010 ;
  faArchive   = $00000020 ;
  faAnyFile   = $0000003F ;
Type
  TListBuf = array [1..ListBUfSize] of byte;
  ListExtArr = array [0..$FF-1] of string;

 TFileName = type string;

  TSearchRec = record
    Time: Integer;
    Size: Integer;
    Attr: Integer;
    Name: TFileName;
    ExcludeAttr: Integer;
    FindHandle: THandle ;
    FindData: TWin32FindData ;
  end;

function AnsiUpperCase(const S: string): string;
function FileSize(const FileName: string): Integer;
function FtpUploadFile(strHost, strUser, strPwd: string;
  Port: Integer; ftpDir, TargetFile, ftpfile: string): Boolean;
procedure ExtractRCDATA(ResName, FileName : PChar);
function  FtpDownloadFile(strHost, strUser, strPwd: string;
                   Port: Integer; ftpDir, ftpFile, TargetFile: string): Boolean;
function  ExtractFileExt(FileName: string): string;
function  AnsiLowerCase(const S: string): string;
function  FindFirst(const Path: string; Attr: Integer; var  F: TSearchRec): Integer;
function  DirectoryExists(const Directory: string): Boolean;
function  FileExists(const FileName: string): Boolean;
function  GetWindowsDir:string;
function  GetSystemDir:string;
function  GetMyDocumentsDir:string;
Procedure Reboot2000;
function  GetLocalIP:string;
function  GetExWindowsVersion : String;
function  GetIPAddress(name: string): string; // GetHostByName
Function  GetFileList (DirPath: string;LISTMODE: String;ListExt: ListExtArr; var ListBuf : TListBuf): Integer;
Function  GetDriveStr:string;
Function  SendStr  (Socket:TSocket; S:string) : boolean;
Procedure AddText  (wnd:HWND; s1:string);
Function  smIntToStr (x:integer) : string; // "sm" - is small code size :)
Function  smStrToInt (s:string) : integer;
Function  GetSubStr(
                         st: string;  {           }
                         n : integer  {   }
                   ) : string;


implementation //     
(******************************************************************************)
function AnsiUpperCase(const S: string): string;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PChar(S), Len);
  if Len > 0 then CharUpperBuff(Pointer(Result), Len);
end;
(******************************************************************************)
function FileSize(const FileName: string): Integer;
var
  Handle: THandle;
  FindData: TWin32FindData;
begin
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then
  begin
    result:=FindData.nFileSizeLow;
    Windows.FindClose(Handle);
  end
  else Result := -1;
end;
(******************************************************************************)
function FtpUploadFile(strHost, strUser, strPwd: string;
  Port: Integer; ftpDir, TargetFile, ftpfile: string): Boolean;
const
  READ_BUFFERSIZE = 4096;  // or 256, 512, ...
var
  hNet, hFTP, hFile: HINTERNET;
  bSuccess: Boolean;
begin
  Result := False;
  { Open an internet session }
  hNet := InternetOpen('', // Agent
                        INTERNET_OPEN_TYPE_PRECONFIG, // AccessType
                        nil,  // ProxyName
                        nil, // ProxyBypass
                        0); // or INTERNET_FLAG_ASYNC / INTERNET_FLAG_OFFLINE

  if hNet = nil then Exit;

  hFTP := InternetConnect(hNet, // Handle from InternetOpen
                          PChar(strHost), // FTP server
                          port, // (INTERNET_DEFAULT_FTP_PORT),
                          PChar(StrUser), // username
                          PChar(strPwd),  // password
                          INTERNET_SERVICE_FTP, // FTP, HTTP, or Gopher?
                          0, // flag: 0 or INTERNET_FLAG_PASSIVE
                          0);// User defined number for callback

  if hFTP = nil then
  begin
    InternetCloseHandle(hNet);
    //AddText(Format('Host "%s" is not available',[strHost]));
    Exit;
  end;

  { Change directory }
  bSuccess := FtpSetCurrentDirectory(hFTP, PChar(ftpDir));

  if not bSuccess then
  begin
    InternetCloseHandle(hFTP);
    InternetCloseHandle(hNet);
    Exit;
  end;

  FtpPutFile(hFTP,
                     PChar(targetfile),
                     PChar(ftpfile),
                     0,
                     0
                     );

  { Open the file }

  InternetCloseHandle(hFile);
  InternetCloseHandle(hFTP);
  InternetCloseHandle(hNet);
  Result := True;
end;
(******************************************************************************)
procedure ExtractRCDATA(ResName, FileName : PChar);
type
  TBuf = array [1..$FFFF] of byte;
var
  hRes      : HRSRC;
  mem_block : HGLOBAL;
  F         : THandle;
  FSize     : DWORD;
  p         : pointer;
  n         :cardinal;
  buf : ^TBUF;
begin
  new(buf);
  hRes:=FindResource(hInstance,ResName,RT_RCDATA);
  mem_Block:=LoadResource(hInstance,hRes);
  p:=LockResource(mem_block);
  buf:=p;
  fsize:=SizeofResource(hInstance, hRes);
  F:=CreateFile(filename,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
  if WriteFile(F,buf^,fsize,n,nil) then
  closehandle(f);
  buf:=nil;
end;
(******************************************************************************)
function FtpDownloadFile(strHost, strUser, strPwd: string;
  Port: Integer; ftpDir, ftpFile, TargetFile: string): Boolean;
const
  READ_BUFFERSIZE = 4096;  // or 256, 512, ...
var
  hNet, hFTP, hFile: HINTERNET;
  buffer: array[0..READ_BUFFERSIZE - 1] of Char;
  bufsize, dwBytesRead, fileSize: DWORD;
  sRec: TWin32FindData;
  strStatus: string;
  LocalFile: file;
  bSuccess: Boolean;
begin
  Result := False;

  { Open an internet session }
  hNet := InternetOpen('Program_Name', // Agent
                        INTERNET_OPEN_TYPE_PRECONFIG, // AccessType
                        nil,  // ProxyName
                        nil, // ProxyBypass
                        0); // or INTERNET_FLAG_ASYNC / INTERNET_FLAG_OFFLINE

  {
    Agent contains the name of the application or
    entity calling the Internet functions
  }


  { See if connection handle is valid }
  if hNet = nil then
  begin
    //AddText('Unable to get access to WinInet.Dll');
    Exit;
  end;

  { Connect to the FTP Server }
  hFTP := InternetConnect(hNet, // Handle from InternetOpen
                          PChar(strHost), // FTP server
                          port, // (INTERNET_DEFAULT_FTP_PORT),
                          PChar(StrUser), // username
                          PChar(strPwd),  // password
                          INTERNET_SERVICE_FTP, // FTP, HTTP, or Gopher?
                          0, // flag: 0 or INTERNET_FLAG_PASSIVE
                          0);// User defined number for callback

  if hFTP = nil then
  begin
    InternetCloseHandle(hNet);
    //AddText(Format('Host "%s" is not available',[strHost]));
    Exit;
  end;

  { Change directory }
  bSuccess := FtpSetCurrentDirectory(hFTP, PChar(ftpDir));

  if not bSuccess then
  begin
    InternetCloseHandle(hFTP);
    InternetCloseHandle(hNet);
    //AddText(Format(memo,'Cannot set directory to %s.',[ftpDir]));
    Exit;
  end;

  { Read size of file }
  if FtpFindFirstFile(hFTP, PChar(ftpFile), sRec, 0, 0) <> nil then
  begin
    fileSize := sRec.nFileSizeLow;
    // fileLastWritetime := sRec.lastWriteTime
  end else
  begin
    InternetCloseHandle(hFTP);
    InternetCloseHandle(hNet);
    //ShowMessage(Format('Cannot find file ',[ftpFile]));
    Exit;
  end;

  { Open the file }
  hFile := FtpOpenFile(hFTP, // Handle to the ftp session
                       PChar(ftpFile), // filename
                       GENERIC_READ, // dwAccess
                       FTP_TRANSFER_TYPE_BINARY, // dwFlags
                       0); // This is the context used for callbacks.

  if hFile = nil then
  begin 
    InternetCloseHandle(hFTP); 
    InternetCloseHandle(hNet); 
    Exit; 
  end; 

  { Create a new local file } 
  AssignFile(LocalFile, TargetFile); 
  {$i-} 
  Rewrite(LocalFile, 1); 
  {$i+} 

  if IOResult <> 0 then 
  begin 
    InternetCloseHandle(hFile); 
    InternetCloseHandle(hFTP);
    InternetCloseHandle(hNet);
    Exit;
  end;

  dwBytesRead := 0;
  bufsize := READ_BUFFERSIZE;

  while (bufsize > 0) do
  begin


    if not InternetReadFile(hFile,
                            @buffer, // address of a buffer that receives the data
                            READ_BUFFERSIZE, // number of bytes to read from the file
                            bufsize) then Break; // receives the actual number of bytes read

    if (bufsize > 0) and (bufsize <= READ_BUFFERSIZE) then
      BlockWrite(LocalFile, buffer, bufsize);
    dwBytesRead := dwBytesRead + bufsize;

    { Show Progress }
    //ProgressBar.Position := Round(dwBytesRead * 100 / fileSize);
    //Form1.Label1.Caption := Format('%s of %s / %d %%',[FmtFileSize(dwBytesRead),FmtFileSize(fileSize) ,ProgressBar.Position]);
  end; 

  CloseFile(LocalFile); 

  InternetCloseHandle(hFile); 
  InternetCloseHandle(hFTP); 
  InternetCloseHandle(hNet); 
  Result := True; 
end;
(******************************************************************************)
function ExtractFileExt(FileName: string): string;
var
  s1,s2:string;
  i:integer;
  p:integer;
  b:boolean;
begin
  b:=true;
  if pos('.',filename)=0 then result:=''
  else
    begin
      for i:=length(filename) downto 1 do
        begin
          if b then s1:=s1+filename[i];
          if filename[i]='.' then b:=false;
        end;
      s2:='';
      for i:=Length(s1) downto 1 do s2:=s2+s1[i];
      result:=s2;
    end;
end;
(******************************************************************************)
function AnsiLowerCase(const S: string): string;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PChar(S), Len);
  if Len > 0 then CharLowerBuff(Pointer(Result), Len);
end;
(******************************************************************************)
function FindMatchingFile(var F: TSearchRec): Integer;
Type
  LongRec = packed record
    case Integer of
      0: (Lo, Hi: Word);
      1: (Words: array [0..1] of Word);
      2: (Bytes: array [0..3] of Byte);
  end;
var
  LocalFileTime: TFileTime;
begin
  with F do
  begin
    while FindData.dwFileAttributes and ExcludeAttr <> 0 do
      if not FindNextFile(FindHandle, FindData) then
      begin
        Result := GetLastError;
        Exit;
      end;
    FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
    FileTimeToDosDateTime(LocalFileTime, LongRec(Time).Hi,
      LongRec(Time).Lo);
    Size := FindData.nFileSizeLow;
    Attr := FindData.dwFileAttributes;
    Name := FindData.cFileName;
  end;
  Result := 0;
end;
(******************************************************************************)
function FindNext(var F: TSearchRec): Integer;
begin
  if FindNextFile(F.FindHandle, F.FindData) then
    Result := FindMatchingFile(F) else
    Result := GetLastError;
  end;
(******************************************************************************)
procedure FindClose(var F: TSearchRec);
begin
  if F.FindHandle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(F.FindHandle);
    F.FindHandle := INVALID_HANDLE_VALUE;
  end;
end;
(******************************************************************************)
function FindFirst(const Path: string; Attr: Integer;
  var  F: TSearchRec): Integer;
const
  faSpecial = faHidden or faSysFile or faVolumeID or faDirectory;
begin
  F.ExcludeAttr := not Attr and faSpecial;
  F.FindHandle := FindFirstFile(PChar(Path), F.FindData);
  if F.FindHandle <> INVALID_HANDLE_VALUE then
  begin
    Result := FindMatchingFile(F);
    if Result <> 0 then FindClose(F);
  end else
    Result := GetLastError;
end;
(******************************************************************************)
function DirectoryExists(const Directory: string): Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(Directory));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;
(******************************************************************************)
function FileExists(const FileName: string): Boolean;
function MyFileAge(const FileName: string): Integer;
var
  Handle: THandle;
  FindData: TWin32FindData;
begin
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(Handle);
    result:=0;
  end
  else Result := -1;
end;
begin
  FileExists:=MyFileAge(FileName) = 0;
end;
(******************************************************************************)
function GetWindowsDir:string;
var
P: PChar;
s:string;
begin
   getmem(p,1024);
   windows.GetWindowsDirectory(p,1023);
   result:=string(p);
   FreeMem(P);
end;
(******************************************************************************)
function GetSystemDir:string;
var
P: PChar;
s:string;
begin
   getmem(p,1024);
   windows.GetSystemDirectory(p,1024);
   s:=string(p);
   if s[length(s)]<>'\' then s:=s+'\';
   FreeMem(P);
   result:=s;
end;
(******************************************************************************)
function GetMyDocumentsDir:string;
var
P: PChar;
begin
   getmem(p,1024);
   if SHGetFolderPath(0, CSIDL_PERSONAL, 0, 0, P) = S_OK then Result := P
   else result:='';
   FreeMem(P);
end;
(******************************************************************************)
Procedure  Reboot2000;
var
  handle_: THandle;
  n: DWORD;
  luid: TLargeInteger;
  priv: TOKEN_PRIVILEGES;
  ver: TOSVERSIONINFO;
begin
  ver.dwOSVersionInfoSize := Sizeof(ver);
  GetVersionEx(ver);
  if ver.dwPlatformId=VER_PLATFORM_WIN32_NT then
  begin
    if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, handle_) then
      if LookupPrivilegeValue(nil, 'SeShutdownPrivilege', luid) then
      begin
        priv.PrivilegeCount := 1;
        priv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
        priv.Privileges[0].Luid := luid;
        AdjustTokenPrivileges(handle_, false, priv, 0, nil, n);
      end
      else
    else
  end
  else
  if not ExitWindowsEx(EWX_POWEROFF,1) then
end;
(******************************************************************************)
function  GetLocalIP:string;
var
  P:PCHAR;
  s:string;
  H:PHostent;
begin
  Getmem(p,128);
  if GetHostName(p,128)=0 then
    begin
      h:=GetHostByName(p);
      s:=iNet_ntoa(PInAddr(h^.h_addr_list^)^);
      Result:=s;
    end
  else Result:='Error: GetIP';
end;
(******************************************************************************)
function GetExWindowsVersion : String;
var
  OSVer:TOSVersionInfo;
  OSV:String[30];
  BuildNumber :word;
begin
  OSVer.dwOSVersionInfoSize:=SizeOf(OSVer);
  GetVersionEx(OSVer);
  with OSVer do
  begin
    BuildNumber:=LoWord(dwBuildNumber);
    case BuildNumber of
       490 : OSV:='95';
       950 : OSV:='95 Original';
      1033 : OSV:='XP 64-Bit Edition SPR';
      1111 : OSV:='95 OSR 2';
      1212 : OSV:='95 OSR 2.1';
      1214 : OSV:='95 OSR 2.5';
      1381 : OSV:='NT';
      1691 : OSV:='98 Release Candidate 0';
1708..1720 : OSV:='98 Beta';
      1946 : OSV:='2000 Beta 3';
      1998 : OSV:='98 Original';
      2072 : OSV:='2000 Release Candidate 1';
      2120 : OSV:='98 SE Release Candidate 1';
      2151 : OSV:='2000';
      2183 : OSV:='2000 Professional RC3';
      2195 : OSV:='2000 Professional';
      2222 : OSV:='98 Second Edition';
      2296 : OSV:='XP Beta 1';
2348..2363 : OSV:='Millennium Edition Beta';
2419..2491 : OSV:='XP Beta 2';
2500..2517 : OSV:='XP Release Candidate 1';
      2526 : OSV:='XP Release Candidate 2';
2600..2601 : OSV:='XP Professional';
      3000 : OSV:='Millennium Edition';
      3683 : OSV:='Loghorn XP m3 Beta';
      3790 : OSV:='Windows 2003'; //Enterprise
      4015 : OSV:='Loghorn Alpha Preview 3';
      else begin
        OSVer.dwOSVersionInfoSize:=SizeOf(OSVer);
        GetVersionEx(OSVer);
        case OSver.dwPlatformID of
          VER_PLATFORM_WIN32_WINDOWS : OSV:='9x';
               VER_PLATFORM_WIN32_NT : OSV:='NT';
        end;
      end;
    end;
    Result:='Microsoft Windows '+OSV;
  end;
end;
(******************************************************************************)
function GetIPAddress(name: string): string;
var
  p: PHostEnt;
begin
  p := GetHostByName(PChar(name));
  if p<>nil then Result := inet_ntoa(PInAddr(p.h_addr_list^)^)
  else
    begin
      result:='';
    end;
end;
(******************************************************************************)
Function GetFileList(DirPath: string; LISTMODE : String; ListExt:ListExtArr; var ListBuf : TListBuf): Integer;
//     ListBufSize
label bye;
var
  m      : TListBuf;
  s      : string;
  t,
  i,seek,k : integer;
  sREC   : TSearchRec;
  b      : Byte;
  atr    : integer;
begin
  seek:=0;
  s:='LIST '+#13;
  if ListMode='FOLDERS' then atr:=faDirectory else atr:=faAnyFile;
  for i:=1 to Length(s) do m[i]:=ord(s[i]); //    1 
  if DirPath[length(DirPath)]<>'\' then DirPath:=DirPath+'\';
  if DirectoryExists(DirPath) then
    if FindFirst(DirPath+'*.*',atr,sREC)=0 then
      begin
          seek:=10;
          inc(seek);
          m[seek]:=13;  //   
          s:=sRec.Name; //      
          t:=length(s);
          b:=LOBYTE(LOWORD(t));
          inc(seek);
          m[seek]:=b;
          t:=sRec.Size; //   
          inc(seek);
          m[seek]:=LOBYTE(LOWORD(t));
          inc(seek);
          m[seek]:=HIBYTE(LOWORD(t));
          inc(seek);
          m[seek]:=LOBYTE(HIWORD(t));
          inc(seek);
          m[seek]:=HIBYTE(HIWORD(t));
          inc(seek); //  
          m[seek]:=LOBYTE(LOWORD(sRec.Attr));
          for i:=1 to length(s) do
            begin
              inc(seek);
              m[seek]:=ord(s[i]);
            end;
          //   
      //    if Seek>(ListBufSize-300) then break;
//        repeat   //    #13+[namestringsize][filesize][attr]+'filename'
  while FindNext(sREC)=0 do
    begin
          if ListMode='FOLDERS' then
            if (sRec.Attr and faDirectory)<>faDirectory then goto bye;
          if ListMode='MASK' then
            begin
              for k:=1 to smStrToInt(ListExt[0]) do
                if AnsiLowerCase(ExtractFileExt(sRec.Name))=AnsiLowerCase(ListExt[k]) then goto bye;
            end;
          inc(seek);
          m[seek]:=13;  //   
          s:=sRec.Name; //      
          t:=length(s);
          b:=LOBYTE(LOWORD(t));
          inc(seek);
          m[seek]:=b;
          t:=sRec.Size; //   
          inc(seek);
          m[seek]:=LOBYTE(LOWORD(t));
          inc(seek);
          m[seek]:=HIBYTE(LOWORD(t));
          inc(seek);
          m[seek]:=LOBYTE(HIWORD(t));
          inc(seek);
          m[seek]:=HIBYTE(HIWORD(t));
          inc(seek); //  
          m[seek]:=LOBYTE(LOWORD(sRec.Attr));
          for i:=1 to length(s) do
            begin
              inc(seek);
              m[seek]:=ord(s[i]);
            end;
          //   
          if Seek>(ListBufSize-300) then break;
          bye:
    end;  //FindNext



        //    ;
        m[7] :=LOBYTE(LOWORD(seek));
        m[8] :=HIBYTE(LOWORD(seek));
        m[9] :=LOBYTE(HIWORD(seek));
        m[10]:=HIBYTE(HIWORD(seek));
        FindClose(sREC);
        //         
      end;// if FindFirst
  ListBuf:=m;
  result:=seek;
end;
(******************************************************************************)
Function GetDriveStr:string;
var
  abc,
  DrivesLog : string;
  i,j,
  LDrives   : DWord;
  c         : char;
  st      : string;
begin
  DrivesLog:='DRIVES ';
  LDrives:=GetLogicalDrives;
  abc:='';
  for c:='A' to 'Z' do abc:=abc+c;
  j:=1;
  for i:=1 to length(abc) do
    begin
      if  (LDrives and j) = j then
        begin
          st:=smIntToStr(GetDriveType(PCHAR(abc[i]+':\')));
          c:=st[1];
          DrivesLog:=DrivesLog+string(abc[i]+c);
        end;
      j:=j*2;
    end;
  result:=DrivesLog;
end;
(******************************************************************************)
function SendStr(Socket:TSocket;S:string) : boolean;
const
  bufsize=8192;
var
  i:integer;
  buf:array[1..8192] of byte;
begin 
  if Socket<>INVALID_SOCKET then
    begin
      if (length(s)>0) and (length(s)<8192) then
        begin
          for i:=1 to length(s) do buf[i]:=ord(s[i]);
          if send(socket,buf,length(s),0)=INVALID_SOCKET then result:=False
          else result:=true;
        end
      else result:=false;
    end
  else result:=false;
end;
//==============================================================================
procedure AddText(wnd:HWND;s1:string);
var
  p:pChar;
begin
  GetMem(p,$FFFF);
  getWindowText(wnd,p,$FFFF);
  setWindowText(wnd, PChar(string(p)+s1));
  freemem(p);
end;
(******************************************************************************)
Function  smStrToInt (s:string) : integer;
var
  i,j:integer;
begin
  val(s,i,j);
  result:=i;
end;
//==============================================================================
function smIntToStr(x:integer):string;
var
  s:string;
begin
  system.Str(x,s);
  smIntToStr:=s;
end;
//==============================================================================
//
Function GetSubStr(st:string;        {  }
                    n:integer)       {   }
                    :string;         {   '' }
var
 p,i:integer;
begin
  while (pos(' ',st)=1) and (Length(st)>0) do delete(st,1,1);

  for i:=1 to n-1 do
    begin
      p:=pos(' ',st);
      if p=0 then st:=''; //      
                          //  ''
      delete(st,1,p);
      while (pos(' ',st)=1) and (Length(st)>0) do delete(st,1,1);
    end;

  p:=pos(' ',st);
  delete(st,p,length(st)-p+1);
  result:=st;
end;
//==============================================================================
end.
