unit FilterDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles;

type
  TFilterDlg = class(TForm)
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    L1: TLabel;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FilterDlg: TFilterDlg;

implementation

{$R *.dfm}
(******************************************************************************)
procedure TFilterDlg.Button1Click(Sender: TObject);
begin
  ListBox1.Items.Add(edit1.Text);
  edit1.Text:='';
  edit1.Focused;
end;
(******************************************************************************)
procedure TFilterDlg.Button2Click(Sender: TObject);
begin
  ListBox1.Items.Delete(ListBox1.ItemIndex);
end;
(******************************************************************************)
procedure TFilterDlg.Button3Click(Sender: TObject);
var
  i:integer;
  ini: TInifile;
begin
  ini:=TIniFile.Create( ChangeFileExt(ParamStr(0),'.ini'));
  ini.EraseSection('Exts');
  ini.WriteString('Num','Count',inttostr(ListBox1.Count));
  for i:=0 to ListBox1.Count-1 do
    ini.WriteString('Exts','Ext'+inttostr(i),ListBox1.Items[i]);
  ini.Free;
  close;
end;
(******************************************************************************)
procedure TFilterDlg.FormActivate(Sender: TObject);
var
  ini : TiniFile;
  i : integer;
  Count: integer;
begin
  GroupBox1.Caption:='  ';
  ListBox1.Clear;
  ini:=TIniFile.Create( ChangeFileExt(ParamStr(0),'.ini'));
  count:=StrToInt(ini.ReadString('Num','Count','0'));
  for i:= 0 to count-1 do ListBox1.Items.Add(ini.ReadString('Exts','Ext'+inttostr(i),''));
  ini.Free;
end;

end.
